%if 0%{?fedora}
# There are some missing deps
%global with_python3 0
%endif

%global pypi_name os-brick

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           python-%{pypi_name}
Version:        1.1.0
Release:        7%{?dist}
Provides:        python2-os-brick = %{version}-%{release}
Summary:        OpenStack Cinder brick library for managing local volume attaches

License:        ASL 2.0
URL:            http://www.openstack.org/
Source0:        https://pypi.python.org/packages/source/o/%{pypi_name}/%{pypi_name}-%{version}.tar.gz

# patches_base=1.1.0+4
Patch0001: 0001-Fix-cmd-execution-stderr-stdout-unicode-errors.patch
Patch0002: 0002-Fix-iSCSI-multipath-cleanup.patch
Patch0003: 0003-Fix-FC-multipath-cleanup.patch
Patch0004: 0004-Fix-FC-multipath-rescan.patch
Patch0005: 0005-Make-RBDImageMetadata-and-RBDVolumeIOWrapper-re-usab.patch
Patch0006: 0006-Close-connection-to-ceph-after-cinder-bakcup.patch
Patch0007: 0007-Fix-wrong-path-used-in-iscsi-multipath-l.patch
Patch0008: 0008-Fix-iSCSI-multipath-rescan.patch
Patch0009: 0009-Refactor-iSCSI-disconnect.patch
Patch0010: 0010-Refactor-iSCSI-connect.patch
Patch0011: 0011-Add-open-iscsi-manual-scan-support.patch
Patch0012: 0012-Fix-iSCSI-cleanup-issue-when-using-discovery.patch
Patch0013: 0013-iSCSI-multipath-improve-logging-on-connect.patch
Patch0014: 0014-Fix-manual-scan-for-discovery-type-backends.patch
Patch0015: 0015-Fix-iSCSI-cleanup-fix-on-discovery-backends.patch
Patch0016: 0016-Return-symlinks-for-encrypted-volumes.patch
Patch0017: 0017-Return-WWN-in-multipath_id.patch
Patch0018: 0018-Don-t-obscure-logs-on-iSCSI-sendtargets-failure.patch
Patch0019: 0019-Get-the-right-portal-from-output-of-iscsiadm-command.patch
Patch0020: 0020-Fix-ISCSIConnector._get_potential_volume_paths-logic.patch
Patch0021: 0021-Fix-iSCSI-volume-attachment-over-RDMA-transport.patch
Patch0022: 0022-Protect-against-race-within-os.path.realpath.patch

BuildArch:      noarch

Provides:       os-brick = %{version}-%{release}
Requires:       python-babel >= 1.3
Requires:       python-eventlet >= 0.17.4
Requires:       python-oslo-serialization >= 1.4.0
Requires:       python-oslo-concurrency >= 2.3.0
Requires:       python-oslo-i18n >= 1.5.0
Requires:       python-oslo-log >= 1.8.0
Requires:       python-oslo-service >= 0.7.0
Requires:       python-oslo-utils >= 2.0.0
Requires:       python-requests >= 2.5.2
Requires:       python-retrying
Requires:       python-six >= 1.9.0
BuildRequires:  python-devel
BuildRequires:  python-pbr >= 1.6.0
BuildRequires:  python-reno
BuildRequires:  python-sphinx
BuildRequires:  python-oslo-concurrency  >= 2.3.0
BuildRequires:  python-oslo-i18n >= 1.5.0
BuildRequires:  python-oslo-log >= 1.8.0
BuildRequires:  python-oslo-service >= 0.7.0
BuildRequires:  python-oslo-sphinx >= 2.5.0
BuildRequires:  python-requests >= 2.5.2
BuildRequires:  python-six >= 1.9.0
BuildRequires:  python-setuptools
%description
OpenStack Cinder brick library for managing local volume attaches

%if 0%{?with_python3}
%package -n python3-%{pypi_name}
Summary:        OpenStack Cinder brick library for managing local volume attaches
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3-babel >= 1.3
Requires:       python3-eventlet >= 0.17.4
Requires:       python3-oslo-serialization >= 1.4.0
Requires:       python3-oslo-concurrency >= 2.3.0
Requires:       python3-oslo-i18n >= 1.5.0
Requires:       python3-oslo-log >= 1.8.0
Requires:       python3-oslo-service >= 0.7.0
Requires:       python3-oslo-utils >= 2.0.0
Requires:       python3-requests >= 2.5.2
Requires:       python3-retrying
Requires:       python3-six >= 1.9.0

BuildRequires:  python3-devel
BuildRequires:  python3-pbr >= 1.6.0
BuildRequires:  python3-reno
BuildRequires:  python3-sphinx
BuildRequires:  python3-oslo-concurrency  >= 2.3.0
BuildRequires:  python3-oslo-i18n >= 1.5.0
BuildRequires:  python3-oslo-log >= 1.8.0
BuildRequires:  python3-oslo-service >= 0.7.0
BuildRequires:  python3-oslo-sphinx >= 2.5.0
BuildRequires:  python3-requests >= 2.5.2
BuildRequires:  python3-six >= 1.9.0
BuildRequires:  python3-setuptools

%description -n python3-%{pypi_name}
OpenStack Cinder brick library for managing local volume attaches

%endif

%prep
%setup -q -n %{pypi_name}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1

%build
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} build --executable="%{__python2} -s"
%if 0%{?with_python3}
%py3_build
%endif

%install
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} install -O1 --skip-build --root %{buildroot}
# generate html docs
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

%if 0%{?with_python3}
%py3_install
%endif

# Move config files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap
mv %{buildroot}/usr/etc/os-brick/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap

%files -n python-%{pypi_name}
%license LICENSE
%doc html README.rst
%{python2_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}

%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%license LICENSE
%doc html README.rst
%{python3_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%endif

%changelog
* Tue Oct 24 2017 Gorka Eguileor <geguileo@redhat.com> 1.1.0-7
- Protect against race within os.path.realpath (RHBZ#1503262)

* Fri Sep 01 2017 Gorka Eguileor <geguileo@redhat.com> 1.1.0-6
- Refactor iSCSI to increase reliability (RHBZ#1440576)

* Thu Mar 30 2017 Eric Harney <eharney@redhat.com> 1.1.0-5
- Fix wrong path used in iscsi "multipath -l" (RHBZ #1432315)

* Mon Nov 21 2016 Eric Harney <eharney@redhat.com> 1.1.0-4
- Close connection to Ceph after Cinder backup (RHBZ #1372235)

* Thu Sep 22 2016 Eric Harney <eharney@redhat.com> 1.1.0-3
- Fix iSCSI/FC multipath cleanup and rescan (RHBZ #1372431)

* Tue Aug 30 2016 Eric Harney <eharney@redhat.com> 1.1.0-2
- Fix cmd execution unicode errors (RHBZ #1371696)

* Wed Mar 23 2016 Haikel Guemar <hguemar@fedoraproject.org> 1.1.0-1
- Update to 1.1.0

